Imports System.IO
Imports System.Data
Imports System.Data.OleDb

Public Class frmIEnumerableOf
    Private Animals As IEnumerable(Of String()) = _
        Permutations.Of("ant bat cow dog".Split(" "c))

    Private Sub Button_Click(ByVal sender As Object, ByVal e As EventArgs) _
        Handles btAllPermutations.Click, btAntAsSecondMember.Click, _
        btPriceOfAll.Click

        Select Case True
            Case sender Is btAllPermutations
                Dim All = From P In Animals Select String.Join(" "c, P)
                MsgBox(String.Join(NewLine, All.ToArray), , _
                    "Alle Permutationen")

            Case sender Is btAntAsSecondMember
                Dim AntsOnSecond = From P In Animals _
                    Where P(1) = "ant" Select String.Join(" "c, P)
                MsgBox(String.Join(NewLine, AntsOnSecond.ToArray), , _
                    "'ant' an zweiter Stelle")

            Case sender Is btPriceOfAll
            Using TP = New Microsoft.VisualBasic.FileIO.TextFieldParser( _
                "..\..\Article.csv")

                With TP
                    .HasFieldsEnclosedInQuotes = True
                    .TextFieldType = FileIO.FieldType.Delimited
                    .Delimiters = New String() {";"}
                    .ReadLine() ' Header berspringen
                End With
                Dim Val = Article.GetRecords(TP).Sum( _
                    Function(A) A.UnitPrice * A.UnitsInStock)
                MsgBox(String.Format("Der gesamte Warenbestand hat einen " & _
                    "Verkaufswert von {0:c}", Val))
            End Using
        End Select
    End Sub
End Class
